DROP PROCEDURE IF EXISTS public.sp_cleanfrllorequestprocess;
DROP PROCEDURE IF EXISTS dbo.sp_cleanfrllorequestprocess;
DROP PROCEDURE IF EXISTS rds.sp_cleanfrllorequestprocess;

CREATE OR REPLACE PROCEDURE rds.sp_cleanfrllorequestprocess(
    "ExportId" uuid DEFAULT NULL
)
    LANGUAGE plpgsql
AS
$$
DECLARE
    p_exportid uuid := "ExportId";
    v_num      int  := 1000;
BEGIN
    CREATE TEMP TABLE tmp_obj
    (
        id  uuid NOT NULL UNIQUE,
        num serial
    );
    
    INSERT INTO
        tmp_obj (id)
    SELECT DISTINCT fed.exportfrllodrugrequestitemid
    FROM rds.t_export_frllo_drug_request_item fed
    WHERE fed.exportfrllodrugrequest = p_exportid;
    
    LOOP
        IF
            NOT EXISTS (SELECT 1 FROM tmp_obj LIMIT 1)
        THEN
            EXIT;
        END IF;
        UPDATE rds.t_export_frllo_drug_request_item fed
        SET frlloid     = NULL,
            frllostatus = NULL,
            FrlloPersNeedsId = NULL,
            frlloerror  = NULL
        WHERE EXISTS(SELECT 1 FROM tmp_obj t WHERE t.id = exportfrllodrugrequestitemid AND t.num <= v_num)
          AND exportfrllodrugrequest = p_exportid;
        
        DELETE FROM tmp_obj WHERE num <= v_num;
        v_num := v_num + 1000;
    END LOOP;

END;
$$